#ifdef _WIN32
#include <windows.h>
#include <process.h>
#else
#include "WinAPI.h"
#endif

#include <time.h>
#include <string.h>
#include <algorithm>
#include <string>
#include <memory>
#include <queue>

#include "Sikou.h"
#include "USIUtil.h"

using namespace std;

extern auto_ptr<Joseki> joseki;
extern Kyokumen *shoki;

extern bool isStopReceived; // stopR}hM
extern bool canPonder; // ǂ݉\
extern bool isPonderThink; // ǂݎvl
extern bool isTsumeThink; // l𓚎vl
extern unsigned long thinkStartTime; // vlJn
extern unsigned long hashCount; // nbVɒǉꂽ
extern unsigned long ponderhitReceiveTime; // ponderhitM
extern bool isInfinite; // vlԂǂ
extern int thinkDepthMax; // ǂ݂̍ő[
extern int InaniwaTimeTesu;     //ina//
extern int InaniwaKomagumiTesu; //ina//
extern Te  InaniwaLastTe;       //ina//

// GWݒt@C̃pX
#ifdef _WIN32
//ina// const char* iniFilePath = ".\\Lesserkai.ini";
const char* iniFilePath = ".\\inaniwa.ini"; //ina//
#else
//ina// const char* iniFilePath = "./Lesserkai.ini";
const char* iniFilePath = "./inaniwa.ini";  //ina//
#endif

#ifdef __GNUC__

#define CRITICAL_SECTION pthread_mutex_t
#define InitializeCriticalSection(a) pthread_mutex_init(a, NULL)
#define EnterCriticalSection(a) pthread_mutex_lock(a)
#define LeaveCriticalSection(a) pthread_mutex_unlock(a)
#define DeleteCriticalSection(a) pthread_mutex_destroy(a)
#define Sleep(a) usleep((a) * 1000)

#endif

queue<string> commandQueue; // MR}hǉ邽߂̃L[

CRITICAL_SECTION cs; // NeBJZNVIuWFNg
// commandQueueɑ΂āAReceiveThread()WaitCommand()
// ɃANZXłȂ悤AcommandQueueɃANZX镔
// NeBJZNVɂB

// R}hM̂߂̊֐BvlłMł悤ɁAXbh炱̊֐ĂяoB
#ifdef _WIN32
void ReceiveThread(void *)
#else
void *ReceiveThread(void *)
#endif
{
	char buf[10000];
	while (true) {
		fgets(buf, 10000, stdin);
		buf[strlen(buf) - 1] = 0; // sR[hB

		if (strncmp(buf, "quit", strlen("quit")) == 0) {
			while (commandQueue.size() > 0) {
				// GWݒ_CAOOKƁAsetoptionquitđĂB
				// ̎Asetoption̓esOexit()Ă΂Ȃ悤AquitR}h
				// OɎMR}hSĎsĂI悤ɂB
				// {́AcommandQueuẽTCY0ƂāAȑÕR}h{
				// sꂽƂۏ؂͂ȂipopŁA܂sỎ\̂ŁjA
				// setoptionɊւĂ͎s200ms邱Ƃ͂Ȃ̂ŁȂ΍􂾂ōς܂
				// ƂɂB
				Sleep(200);
			}
			// IOɃNeBJZNVIuWFNgjB
			DeleteCriticalSection(&cs);
			// quitMGWIB
			exit(0);
		}
		EnterCriticalSection(&cs); // NeBJZNVɓB
		if (strncmp(buf, "stop", strlen("stop")) == 0) {
			isStopReceived = true;
		}
		if (strncmp(buf, "ponderhit", strlen("ponderhit")) == 0) {
			ponderhitReceiveTime = timeGetTime();
		}
		if (strncmp(buf, "gameover", strlen("gameover")) == 0) {
			isStopReceived = true; // ǂݒgameoverĂꍇAvlł؂B
		}
		string commandStr = buf;
		commandQueue.push(commandStr); // R}hL[ɒǉB
		LeaveCriticalSection(&cs); // NeBJZNVoB
	}
}

// MR}hԂB
string WaitCommand()
{
	while (commandQueue.empty()) {
		Sleep(100);
	}
	EnterCriticalSection(&cs); // NeBJZNVɓB
	string commandStr = commandQueue.front(); // L[R}h擾B
	commandQueue.pop(); // L[R}h폜B
	LeaveCriticalSection(&cs); // NeBJZNVoB
	return commandStr;
}

// R}hMXbhJnB
bool BeginThread()
{
#ifdef _WIN32
	uintptr_t hdl = _beginthread(ReceiveThread, 0, NULL);
	return (hdl != -1);
#else
	pthread_t thread;
	int err = pthread_create(&thread , NULL , ReceiveThread , NULL);
	return (err == 0);
#endif
}

int main()
{
	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0); // ꂪKviWo͂̃obt@O𖳌ɂj

	InitializeCriticalSection(&cs); // NeBJZNVIuWFNg̏B
	bool isSuccess = BeginThread(); // MXbhJnB
	if (!isSuccess) {
		printf("Failed to begin thread\n");
		return -1;
	}

	// Lesserkai.init@CȂAGWݒ̃ftHgl擾B
//ina// 	char iniValueBuf[256];
//ina// 	::GetPrivateProfileString("CustomSettings", "BookFile", "public.bin", iniValueBuf, 256, iniFilePath);
//ina// 	string bookFileStr = iniValueBuf;
//ina// 	::GetPrivateProfileString("CustomSettings", "UseBook", "true", iniValueBuf, 256, iniFilePath);
//ina// 	string useBookStr = iniValueBuf;
//ina// 	bool isUseJoseki = useBookStr == "true";
	bool isUseJoseki = false; //ina//

	srand((unsigned)time(NULL)); // Sikou::Think()ŒՂ_ɑIׂ悤ɂ邽߁B
	Kyokumen::HashInit();
	
	// ̏zułB₷łHῗ̕GłǁB
	KomaInf HirateBan[9][9]={
		{EKY,EKE,EGI,EKI,EOU,EKI,EGI,EKE,EKY},
		{EMP,EHI,EMP,EMP,EMP,EMP,EMP,EKA,EMP},
		{EFU,EFU,EFU,EFU,EFU,EFU,EFU,EFU,EFU},
		{EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP},
		{EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP},
		{EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP,EMP},
		{SFU,SFU,SFU,SFU,SFU,SFU,SFU,SFU,SFU},
		{EMP,SKA,EMP,EMP,EMP,EMP,EMP,SHI,EMP},
		{SKY,SKE,SGI,SKI,SOU,SKI,SGI,SKE,SKY}
	};
	// ͖ʓ|łEHI܂0ׂȂƂ܂B
	int HirateMotigoma[EHI+1]={
	// jp򉤂ƈǌ\Snjp
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	};
	// 菉ǖʈȊOJn鎞ɎgB
	int customMotigoma[EHI+1]={
	// jp򉤂ƈǌ\Snjp
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	};
	KyokumenKomagumi::InitKanagomaValue();
	shoki=new Kyokumen(0, HirateBan, HirateMotigoma);

	while (true) {
		while (true) {
			// ΋Ǒ҂̃[vBsetoptionR}hĂ炻̒lݒ肷B
			// usinewgameR}hĂ炱̃[v𔲂đ΋ǂ̃[vɓB

			string commandStr = WaitCommand(); // MR}h擾
			const char *buf = commandStr.c_str();
			int len = strlen(buf);
			if (strncmp(buf, "usi", len) == 0) {
				// GWNAԍŏɌĂ΂R}hBɑ΂ăGWidԂƁA
				// GWŐݒ\ȃp[^optionR}hŕԂAŌusiokԂKvB
//ina// 				printf("id name Lesserkai 1.3.3\n");
				printf("id name inaniwa 1.0.0\n"); //ina//
//ina// 				printf("id author Program Writer\n");
				printf("id author inaniwa3\n"); //ina//
//ina// 				printf("option name BookFile type string default %s\n", bookFileStr.c_str());
//ina// 				printf("option name UseBook type check default %s\n", isUseJoseki ? "true" : "false");
				printf("usiok\n");
			} else if (strncmp(buf, "isready", len) == 0) {
				// {̓ƊmۂłǂׂĂreadyokԂׂ
				// ʓ|Ȃ̂ŉׂreadyokԂĂB
				printf("readyok\n");
			} else if (strncmp(buf, "setoption", strlen("setoption")) == 0) {
				// GWɐݒ肷p[^Ă̂łݒ肵A
				// GWŗL̃p[^łΏݒt@CɕۑB
				if (strncmp(buf, "setoption name USI_Ponder value true", len) == 0) {
					canPonder = true;
				} else if (strncmp(buf, "setoption name USI_Ponder value false", len) == 0) {
					canPonder = false;
				} else if (strncmp(buf, "setoption name USI_Hash value ", strlen("setoption name USI_Hash value ")) == 0) {
					string hashStr = buf + strlen("setoption name USI_Hash value ");
					// int hashSize = atoi(hashStr.c_str());
					// {ł΁A̒lɃnbVTCYݒ肷ׂłB
//ina// 				} else if (strncmp(buf, "setoption name BookFile value ", strlen("setoption name BookFile value ")) == 0) {
//ina// 					bookFileStr = buf + strlen("setoption name BookFile value ");
//ina// 					// ݒt@CɕۑĂ
//ina// 					::WritePrivateProfileString("CustomSettings", "BookFile", bookFileStr.c_str(), iniFilePath);
//ina// 				} else if (strncmp(buf, "setoption name UseBook value ", strlen("setoption name UseBook value ")) == 0) {
//ina// 					useBookStr = buf + strlen("setoption name UseBook value ");
//ina// 					isUseJoseki = useBookStr == "true";
//ina// 					// ݒt@CɕۑĂ
//ina// 					::WritePrivateProfileString("CustomSettings", "UseBook", isUseJoseki ? "true" : "false", iniFilePath);
				}
			} else if (strncmp(buf, "usinewgame", len) == 0) {
				// VK΋ǊJñR}hBM炱̃[v𔲂B
				break;
			}
		}

//ina// 		if (joseki.get() == NULL) {
//ina// 			// Ճt@Cw肳ĂāA܂ǂłȂÃt@CǂݍށB
//ina// 			joseki.reset(new Joseki((char *)bookFileStr.c_str()));
//ina// 		}

		KyokumenKomagumi k; // ݂̋ǖ
		KomaInf customBan[9][9]; // 菉ǖʈȊŐǖʂJn鎞ɎgB
		memset(customBan, 0, sizeof(customBan));

		// ͂܂ȒPȎvlȂ̂ŁAȒPłB
		Sikou sikou;
		sikou.ClearHash(); // nbVSăNABiKvǂsǁj
		hashCount = 0; // nbV̎gp0ɖ߂ĂB
		isStopReceived = false;

		// ̋ǖʂŁAő̎萔͂TVX肾łB
		Te teBuf[600];
		int SorE; // ̎ԁBSELF or ENEMY
		int teNum; // \Ȏ萔
		Te te(0); // GWԂw
		Te ponderTe(0); // GW̎wɑ΂鑊̗\z
		InaniwaTimeTesu = INANIWA_MAX_TESU; //ina//
		InaniwaKomagumiTesu = 9; //ina//

		while (true) {
			// ΋ǂ̃[vB΋ǎ̃R}ĥ͂̒ōsB
			// gameoverR}hĂ炱̃[v𔲂đ΋Ǒ҂̃[vɖ߂B

			string commandStr = WaitCommand(); // MR}h擾B
			const char *buf = commandStr.c_str();
			int len = strlen(buf);
			if (strncmp(buf, "position", strlen("position")) == 0) {
				// ݋ǖʂw肷R}hB
				if (strncmp(buf, "position startpos", strlen("position startpos")) == 0) {
					// 菉ǖʂ̊Jn
					k.InitKyokumen(0, HirateBan, HirateMotigoma);
					k.Initialize();
					SorE = SELF;
					teNum = k.MakeLegalMoves(SorE, teBuf);
					if (commandStr.find(" moves ") != string::npos) {
						// Jnǖʌ̎w̏񂪂ꍇAǖʂi߂B
						SorE = USIUtil::AddAllMoves(buf, len, &k, SorE, teNum, teBuf);
					}
				} else {
					// SFENŎw肳ǖʂ̊Jn
					USIUtil::ClearMochigoma(customMotigoma); // KvB
					USIUtil::MakeCustomKyokumen(buf, customBan, customMotigoma); // Jnǖʏ
					k.InitKyokumen(0, customBan, customMotigoma);
					k.Initialize();

					SorE = commandStr.find(" w ") != string::npos ? ENEMY : SELF;
					// commandStr.find(" b ") != string::nposƂgƁA̎p
					// ꍇ" b "Ƃ񂪊܂܂Ă܂̂ŁAKԂƔfĂ܂肪B
					// h߂commandStr.find(" w ") != string::nposƂg悤ɕύXB

					teNum = k.MakeLegalMoves(SorE, teBuf);
					if (commandStr.find(" moves ") != string::npos) {
						// Jnǖʌ̎w̏񂪂ꍇAǖʂi߂B
						SorE = USIUtil::AddAllMoves(buf, len, &k, SorE, teNum, teBuf);
					}
					isUseJoseki = false; // ̒ՂȂ̂falseɂĂB
				}
				continue;
			} else if (strncmp(buf, "go", strlen("go")) == 0 &&
					strncmp(buf, "go ponder", strlen("go ponder")) != 0 &&
					strncmp(buf, "go mate", strlen("go mate")) != 0) {
				const char *pbuf;                                                                        //ina//
				if ( (SorE == SELF  && (pbuf = strstr(buf, "wtime ")) != NULL) ||                        //ina//
					 (SorE == ENEMY && (pbuf = strstr(buf, "btime ")) != NULL)  ) {                      //ina//
					int tm = atoi(pbuf+6)/1000;                                                          //ina//
					if (tm >= 3600) {                                                                    //ina//
						printf("info string ̎c莞 %02d:%02d:%02d\n", tm/3600, tm/60%60, tm%60); //ina//
					} else {                                                                             //ina//
						printf("info string ̎c莞 %02d:%02d\n", tm/60, tm%60);                  //ina//
					}                                                                                    //ina//
				}                                                                                        //ina//
				// ݋ǖʂ̎vlJnB
				if (teNum == 0) {
					printf("bestmove resign\n");
					continue;
				}
				if (k.IsNyugyokuWin(SorE)) {
					// CSA̓ʃ[ŏ̋ǖʂȂbestmove winԂB
					printf("bestmove win\n");
					continue;
				}
				isPonderThink = false;
				USIUtil::ParseAllTimes(buf, SorE);
				if (strncmp(buf, "go infinite", strlen("go infinite")) == 0) {
					thinkDepthMax = 8; // go infinitȅꍇ8ɂB
				}
				k.SenkeiInit(); // sikou.Think()̑OɂꂪKvB
				te = sikou.Think(SorE, k, isUseJoseki, &ponderTe);

				if (isStopReceived || isInfinite) {
					// vlstopĂꍇAgo infiniteŎvlJnꍇ́Ał͎ԂA
					// ̒if (strncmp(buf, "stop", strlen("stop")) == 0)̒ŕԂB
					continue;
				} else {
					// wԂB
					printf("bestmove ");
					te.Print();
					if (canPonder && !ponderTe.IsNull()) {
						printf(" ponder ");
						ponderTe.Print();
					}
					printf("\n");
				}

				// ǖʂi߂B
				k.Move(SorE,te);
				SorE = SorE == SELF ? ENEMY : SELF;
				teNum = k.MakeLegalMoves(SorE,teBuf);
				continue;
			} else if (strncmp(buf, "go ponder", strlen("go ponder")) == 0) {
				// \zǖʂ̎vlJnBǂ݂Ȃ̂ŁA̒ŎԂĂ͂ȂB
				if (teNum == 0) {
					continue;
				}
				isPonderThink = true;
				USIUtil::ParseAllTimes(buf, SorE);
				k.SenkeiInit(); // sikou.Think()̑OɂꂪKvB
				te = sikou.Think(SorE, k, isUseJoseki, &ponderTe);
				continue;
			} else if (strncmp(buf, "go mate", strlen("go mate")) == 0) {
				// l̎vlJnB
				isTsumeThink = true;
				USIUtil::ParseLimitTimes(buf);
				thinkStartTime = timeGetTime();
				try {
					int val = k.Mate(SorE, 30, te); // [30܂ŒTB
					if (val == 1) { // l񂾏ꍇ
						printf("checkmate");
						int startSorE = SorE;
						Te tsumeTe;
						while (teNum > 0) {
							printf(" ");
							if (SorE == startSorE) {
								// l߂nbV擾B
								tsumeTe = k.GetTsumeTe(SorE);
							} else {
								// 󂯂͂ǂꂪőP킩Ȃ̂ŁA\Ȏ̂
								// ŏɐɂB
								tsumeTe = teBuf[0];
							}
							tsumeTe.Print();
							k.Move(SorE, tsumeTe);
							SorE = SorE == SELF ? ENEMY : SELF;
							teNum = k.MakeLegalMoves(SorE,teBuf);
						}
					} else { // l܂Ȃꍇ
						printf("checkmate nomate");
					}
				} catch (int) { // Ԑ؂̏ꍇ
					printf("checkmate timeout");
				}
				printf("\n");
				isTsumeThink = false;
				continue;
			} else if (strncmp(buf, "stop", strlen("stop")) == 0) {
				isStopReceived = false; // falseɖ߂B

				// go܂go ponderŊɒTς݂̎ԂB
				// goɑ΂stopłΊɋǖʂi߂Ă邵A
				// go ponderɑ΂stopł΋ǖʂi߂Kv͂Ȃiposition
				// Ă܂ĵŁAǖʂɊւĂ͉ύXȂĂ悢B
				printf("bestmove ");
				if (teNum == 0) {
					// ǂ݊Jn_ŋlł瓊B
					printf("resign\n");
					continue;
				}
				te.Print();
				if (canPonder && !ponderTe.IsNull()) {
					printf(" ponder ");
					ponderTe.Print();
				}
				printf("\n");
				continue;
			} else if (strncmp(buf, "ponderhit", strlen("ponderhit")) == 0) {
				// ɓ̂bestmove ... ponder ...ŕԂ\z肪B
				// \z܂ł̋ǖʂ͐ił邪AwɊւĂ͂ŋǖʂi߂KvB

				// ponderhitMO0ɖ߂ĂBbestmoveԂƁA̒ponderhit
				// Ă邱ƂAɂĂ܂ponderhitReceiveTimeݒ肷̂ŁA
				// 0ɂĂ܂Ȃ悤AbestmoveԂO0ɖ߂Ȃ΂ȂB
				ponderhitReceiveTime = 0;

				if (isStopReceived) {
					// lԑ΃GWŁAGW\zlԂwponderhitA
					// ̌A܂GWpĎvlĂ鎞Ɂuwv{^ƁA
					// stopĂB̂悤ɁAponderhitstopđĂꍇA
					// ł͉ԂA̎stopɓƂŎԂB
					continue;
				}
				if (teNum == 0) {
					// teNum==0ƂƂ́Ago pondeȓ̗\zɂċlł܂ƂƂȂ̂ŁA
					// ponderhitɂĂ̒ʂ̎肪瓊B
					printf("bestmove resign\n");
					continue;
				}
				k.Move(SorE,te);
				SorE = SorE == SELF ? ENEMY : SELF;
				teNum = k.MakeLegalMoves(SorE,teBuf);

				// ɒTς݂̎ԂB
				printf("bestmove ");
				te.Print();
				if (canPonder && !ponderTe.IsNull()) {
					printf(" ponder ");
					ponderTe.Print();
				}
				printf("\n");
				continue;
			} else if (strncmp(buf, "gameover", strlen("gameover")) == 0) {
				// gameoverƂR}hUSǏĂɂ͂ȂA΋ǏIGW
				// m点邽߂ɓƎɒǉBM炱̃[v𔲂
				// ΋Ǒ҂̃[vɖ߂B
				// gameover [ win | lose | draw ]Ƃ悤ɁAgameover̂ƂɌʒʒm
				// p[^̂ŁAwK̂ł΂gB
				break;
			}
		}
	}
	return 0;
}
